/************************************************************************************
 * Projet   : DoublesPointeurs
 * Classe   : circ_list.h
 * Auteur   : Ottavio Buonomo
 * Desc.    : Liste générique simplement chainée
 * Version  : 1.0
 * Date     : 12.08.2019
 ***********************************************************************************/

#ifndef DOUBLESPOINTEURS_CIRC_LIST_H
#define DOUBLESPOINTEURS_CIRC_LIST_H

#include <stdbool.h>

typedef struct Element {
    void* content;
    struct Element* next;
} Element;

Element* list_create();
bool list_empty(Element* head);
unsigned int list_count(Element* head);
Element* list_move(Element* head);
Element* list_insert_after(Element* head, void* data);
Element* list_insert_before(Element* head, void* data);
Element* list_search(Element* head, void* data, int (*compare)(void*, void*));
Element* list_remove(Element* head, void* data, int (*compare)(void*, void*));
void list_free(Element* head, void (*data_free)(void*));
void list_process(Element* head, void* (*action)(void*));
int compare(void* this, void* other);

#endif //DOUBLESPOINTEURS_CIRC_LIST_H
