/************************************************************************************
 * Projet   : DoublesPointeurs
 * Classe   : joseph.c
 * Auteur   : Ottavio Buonomo
 * Desc.    : Résolution du problème de joseph
 * Version  : 1.0
 * Date     : 12.08.2019
 ***********************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "circ_list.h"

/// Insert un élément dans la liste circulaire
/// \param head - entrée de la liste
/// \param value - valeur à ajouter
/// \return nouvelle liste circulaire
Element* insert(Element *head, void* value) {
    if (list_empty(head)) {
        Element *newElement = malloc(sizeof(Element));
        newElement->content = value;
        newElement->next = newElement;
        return newElement;
    } else {
        return list_insert_after(head, value);
    }
}

/// Supprime un élément de la liste circulaire
/// \param head - entrée de la liste
/// \param jump - saut
/// \return dernier élément supprimé
Element* delete(Element *head, int jump) {
    Element *p = head;
    Element *q = head;

    while (p->next != p) {
        for (int i = 0; i < jump - 1; ++i) {
            q = p;
            p = p->next;
        }
        q->next = p->next;
        printf("%d\n", (int)p->content);
        free(p);
        p = q->next;
    }

    head = p;
    return head;
}

int main(int argc, char *argv[]) {
    Element *head = list_create();

    for (int i = 1; i <= atoi(argv[1]); ++i) {
        head = insert(head, i);
    }
    head = head->next;
    printf("%d\n", (int)delete(head, atoi(argv[2]))->content);
    return 0;
}