/************************************************************************************
 * Projet   : DoublesPointeurs
 * Classe   : pointer_sort.c
 * Auteur   : Ottavio Buonomo
 * Desc.    : Tri à bulles par pointeurs
 * Version  : 1.0
 * Date     : 12.08.2019
 ***********************************************************************************/

#include <stdlib.h>
#include <time.h>
#include <stdio.h>


/// Echange deux nombres
/// \param a - nombre 1
/// \param b - nombre 2
void swap(int *a, int *b){
    int temp;
    temp = *a;
    *a = *b;
    *b = temp;
}

/// Tri un tableau par le tri a bulles
/// \param table - tableau à trier
/// \param listSize - taille du tableau à trier
/// \return tableau de pointeurs avec valeurs triées
int* bubbleSort(int *table, int listSize) {
    int *ptr = malloc(sizeof(int) * listSize);
    for (int i = 0; i < listSize; ++i) {
        ptr[i] = table[i];
    }
    for (int i = 0; i < listSize - 1; ++i) {
        for (int j = listSize - 1; j > i; --j) {
            if (ptr[j] < ptr[j-1]) {
                swap(&ptr[j], &ptr[j-1]);
            }
        }
    }
    return ptr;
}

/// Affiche le tri
/// \param table - tableau à afficher

/// Affiche le tri
/// \param table - tableau à afficher
/// \param listSize - taille de la liste à afficher
void printSort(int* table, int listSize) {
    for (int i = 0; i < listSize; ++i) {
        printf("%d\n", table[i]);
    }
}

int main(int argc, char *argv[]) {
    int *values = malloc(sizeof(int) * argc - 1);
    for (int i = 1; i < argc; ++i) {
        values[i - 1] = atoi(argv[i]);
    }
    printSort(bubbleSort(values, argc - 1), argc - 1);
}